> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.ada.cx/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.ada.cx/_mcp/server.

# Get an end user

GET https://example.ada.support/api/v2/end-users/{end_user_id}

Get a specific end user by id

Reference: https://docs.ada.cx/reference/end-users/get-end-user-by-id

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `end_user_id` (string, required) — The Ada end_user_id

## Response

### 200

OK

- `end_user_id` (string, optional) — The unique Ada-generated id for the end user
- `external_id` (string, optional, nullable) — Caller-supplied identifier that links this end user to your own system (for example a CRM contact ID or a phone number). Unique per AI Agent. Null if not set. Maximum 36 characters; values are case-insensitive. Available for custom channel integrations only (V1).
- `profile` (EndUserProfile, optional) — The end user's profile information
- `created_at` (string, optional) — The date and time the end user was created
- `updated_at` (string, optional) — The date and time the end user was updated

## Errors

### 400 Bad Request Error

Invalid request

- `errors` (list of ErrorsErrorsItems, required) — A list of errors

### 401 Unauthorized Error

Unauthorized

- `errors` (list of ErrorsErrorsItems, required) — A list of errors

### 404 Not Found Error

Not Found

- `errors` (list of ErrorsErrorsItems, required) — A list of errors

### 429 Too Many Requests Error

Too Many Requests

- `errors` (list of ErrorsErrorsItems, required) — A list of errors

### 500 Internal Server Error

Internal Server Error

- `errors` (list of ErrorsErrorsItems, required) — A list of errors

## Types

### EndUserProfile

The end user's profile information

- `first_name` (string, optional, nullable) — The end user's first name
- `last_name` (string, optional, nullable) — The end user's last name
- `display_name` (string, optional, nullable) — The end user's display name
- `avatar` (string, optional, nullable) — URL to the end user's avatar image
- `email` (string, optional, nullable) — The end user's email address
- `language` (string, optional, nullable) — The end user's language in BCP 47 format
- `metadata` (map from string to any, optional) — A dictionary of arbitrary key, value pairs assigned to the end user - `metadata` keys may only be of type: `string` - `metadata` values may only be one of type: `string`, `boolean`, or `integer`
- `system_properties` (EndUserProfileSystemProperties, optional) — Read-only profile information set by Ada

### ErrorsErrorsItems

- `type` (string, required) — The error type
- `message` (string, required) — The error message
- `details` (string, optional, nullable) — Extra information about the error

### EndUserProfileSystemProperties

Read-only profile information set by Ada

- `sunshine_user_id` (string, optional, nullable) — The Sunshine Conversations user id for the end user

## Examples

**Response**

```json
{
  "end_user_id": "5f7e0e2c1e7c7e000f0f9c3a",
  "profile": {
    "first_name": "Ada",
    "last_name": "Lovelace",
    "display_name": "Ada Lovelace",
    "avatar": "https://example.com/avatars/ada.png",
    "email": "ada.lovelace@ada.cx",
    "language": "en-US",
    "metadata": {
      "example_key1": "example_string_value",
      "example_key2": true,
      "example_key3": 123
    },
    "system_properties": {
      "sunshine_user_id": "5f7e0e2c1e7c7e000f0f9c3a"
    }
  },
  "created_at": "2020-09-20T00:00:00+00:00",
  "updated_at": "2020-09-20T00:00:00+00:00"
}
```

**SDK Code**

```python
import requests

url = "https://example.ada.support/api/v2/end-users/end_user_id"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.ada.support/api/v2/end-users/end_user_id';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://example.ada.support/api/v2/end-users/end_user_id"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.ada.support/api/v2/end-users/end_user_id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://example.ada.support/api/v2/end-users/end_user_id")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://example.ada.support/api/v2/end-users/end_user_id', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.ada.support/api/v2/end-users/end_user_id");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://example.ada.support/api/v2/end-users/end_user_id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```